SHEBANG
# Copyright @BABOLO (C)2009 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon-libexec.m4,v 1.2 2009/09/25 23:55:20 babolo Exp $

mktemp="/usr/bin/mktemp"

JNTROSTUP(anycommand,-libexec,dnl
,dnl
# jailup ${inclass} <command> <dir>
#           dir relative to ${JAILUPDIR}dnl
)

this=${UPLIBDIR}/${genclass}
MTREE=${this}/mtree${suffix}

command="${1}"
cmnd=`${basename} "${command}"`
main_dir="${JAILUPDIR}/${2}"
${mkdir} "${main_dir}"
${up_mdir} "${main_dir}" ${MTREE}
echo "${command}" | ${up_exec} "${main_dir}/libexec"
echo "${main_dir}/libexec/${command}" | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
t=`${mktemp} -t jailup`

  ${ldd} "${main_dir}/libexec/${cmnd}"\
| ${awk}\
    -v command="${command}"\
    'BEGIN{
         c = 0;
     }
     {   d = 0;}
     /^	/ && (FILENAME ~ /^\/dev\/stdin$/){
         l[c++] = $1;
     }
     /COMMAND/ && !(FILENAME ~ /^\/dev\/stdin$/){
         d = 1;
         print "        " command;
     }
     /LIBRARIES/ && !(FILENAME ~ /^\/dev\/stdin$/){
         d = 1;
         for (i = 0; i < c; i++) print "        " l[i];
     }
     !(FILENAME ~ /^\/dev\/stdin$/) && !(d){
         print $0;
     }'\
    /dev/stdin\
    ${MTREE}\
> "${t}"

${up_mtree} "${main_dir}" "${t}"
${rm} -f "${t}"
